:: ==================================================================================
:: NOMBRE:	Reset Windows Update Tool.
:: DESCRIPCIN:	Esta Herramienta restablece la configuracin del Agente de Windows Update.
:: AUTOR:	Manuel Gil.
:: VERSIN:	10.5.3.7
:: WEBSITE:	http://wureset.com
:: ==================================================================================


:: Configura la pantalla de CMD.
:: void mode();
:: /************************************************************************************/
:mode
	echo off
	title Reset Windows Update Tool.
	mode con cols=98 lines=34
	color 17
	cls

	goto getValues
goto :eof
:: /************************************************************************************/


:: Imprime el un mensaje como titulo.
::		@param - text = el texto a imprimir (%*).
:: void print(string text);
:: /*************************************************************************************/
:print
	cls
	echo.
	echo.%nombre% [Versin: %version%]
	echo.Reset Windows Update Tool.
	echo.
	echo.%*
	echo.
goto :eof
:: /*************************************************************************************/


:: Agrega valores en el Registro de Windows.
::		@param - key = llave que se va a modificar (%~1).
::				value = valor que se va a agregar (%~2).
::				type = tipo de registro a agregar (%~3).
::				data = dato del nuevo registro (%~4).
:: void addReg(string key, string value, string type, string data);
:: /*************************************************************************************/
:addReg
	reg add "%~1" /v "%~2" /t "%~3" /d "%~4" /f
goto :eof
:: /*************************************************************************************/


:: Carga los valores del sistema.
:: void getValues();
:: /************************************************************************************/
:getValues
	for /f "tokens=4-5 delims=[] " %%a in ('ver') do set version=%%a%%b
	for %%a in (%version%) do set version=%%a

	if %version% EQU 5.1.2600 (
		:: Nombre: "Microsoft Windows XP"
		set nombre=Microsoft Windows XP
		:: Familia: Windows 5
		set familia=5
		:: Compatibilidad: Si
		set admite=Si
	) else if %version% EQU 5.2.3790 (
		:: Nombre: "Microsoft Windows XP Professional x64 Edition"
		set nombre=Microsoft Windows XP Professional x64 Edition
		:: Familia: Windows 5
		set familia=5
		:: Compatibilidad: Si
		set admite=Si
	) else if %version% EQU 6.0.6000 (
		:: Nombre: "Microsoft Windows Vista"
		set nombre=Microsoft Windows Vista
		:: Familia: Windows 6
		set familia=6
		:: Compatibilidad: Si
		set admite=Si
	) else if %version% EQU 6.0.6001 (
		:: Nombre: "Microsoft Windows Vista SP1"
		set nombre=Microsoft Windows Vista SP1
		:: Familia: Windows 6
		set familia=6
		:: Compatibilidad: Si
		set admite=Si
	) else if %version% EQU 6.0.6002 (
		:: Nombre: "Microsoft Windows Vista SP2"
		set nombre=Microsoft Windows Vista SP2
		:: Familia: Windows 6
		set familia=6
		:: Compatibilidad: Si
		set admite=Si
	) else if %version% EQU 6.1.7600 (
		:: Nombre: "Microsoft Windows 7"
		set nombre=Microsoft Windows 7
		:: Familia: Windows 7
		set familia=7
		:: Compatibilidad: Si
		set admite=Si
	) else if %version% EQU 6.1.7601 (
		:: Nombre: "Microsoft Windows 7 SP1"
		set nombre=Microsoft Windows 7 SP1
		:: Familia: Windows 7
		set familia=7
		:: Compatibilidad: Si
		set admite=Si
	) else if %version% EQU 6.2.9200 (
		:: Nombre: "Microsoft Windows 8"
		set nombre=Microsoft Windows 8
		:: Familia: Windows 8
		set familia=8
		:: Compatibilidad: Si
		set admite=Si
	) else if %version% EQU 6.3.9200 (
		:: Nombre: "Microsoft Windows 8.1"
		set nombre=Microsoft Windows 8.1
		:: Familia: Windows 8
		set familia=8
		:: Compatibilidad: Si
		set admite=Si
	) else if %version% EQU 6.3.9600 (
		:: Nombre: "Microsoft Windows 8.1 Update 1"
		set nombre=Microsoft Windows 8.1 Update 1
		:: Familia: Windows 8
		set familia=8
		:: Compatibilidad: Si
		set admite=Si
	) else (
		ver | find "10.0." > nul
		if %errorlevel% EQU 0 (
			:: Nombre: "Microsoft Windows 10"
			set nombre=Microsoft Windows 10
			:: Familia: Windows 10
			set familia=10
			:: Compatibilidad: Si
			set admite=Si
		) else (
			:: Nombre: "Desconocido"
			set nombre=Desconocido
			:: Compatibilidad: No
			set admite=No
		)
	)

	call :print %nombre% detected . . .

	if %admite% EQU Si goto permission

	call :print Lo sentimos, su sistema operativo no es compatible con esta herramienta.

	echo.    Se produjo un error al verificar su sistema operativo.
	echo.    Puede que est utilizando una versin empresarial o de prueba.
	echo.
	echo.    De no ser as, verifique que su sistema tenga el parche de seguridad correcto.
	echo.

	echo.Presione una tecla para cerrar la ventana . . . 
	pause>nul
goto :eof
:: /************************************************************************************/


:: Verifica los permisos como Administrador.
:: void permission();
:: /************************************************************************************/
:permission
	openfiles>nul 2>&1

	if %errorlevel% EQU 0 goto terms

	call :print Verificando los permisos de administrador.

	echo.    No se tienen permisos para ejecutar esta herramienta.
	echo.    Esta herramienta no funciona sin permisos de administrador.
	echo.
	echo.    Es necesario ejecutar esta herramienta con permisos de administrador.
	echo.

	echo.Presione una tecla para cerrar la ventana . . . 
	pause>nul
goto :eof
:: /************************************************************************************/


:: Imprime los trminos para el uso de la herramienta.
:: void terms();
:: /*************************************************************************************/
:terms
	call :print Trminos y condiciones de uso.

	echo.    Los procedimientos dentro de esta herramienta pueden modificar archivos y la configuracin
	echo.    del Registro de Windows.
	echo.    No se asume ninguna responsabilidad por el uso de esta herramienta.
	echo.
	echo.    Esta herramienta se proporciona sin ningn tipo de garanta. Cualquier dao causado es bajo
	echo.    su propia responsabilidad.
	echo.
	echo.    Los archivos .bat y .cmd casi siempre son marcados por el anti-virus, no dude en revisar el
	echo.    cdigo si no est seguro.
	echo.
	 
	choice /c SN /n /m "Desea continuar con este proceso? (S/N) "
	if %errorlevel% EQU 1 (
		goto menu
	) else if %errorlevel% EQU 2 (
		goto close
	) else if %errorlevel% EQU 9009 (
		echo.Se ha producido un error inesperado.
		echo.
		echo.Presione una tecla para regresar al men . . . 
		pause>nul
		goto menu
	)
goto :eof
:: /*************************************************************************************/


:: Crea el men de acceso al activador de componentes.
:: void menu();
:: /*************************************************************************************/
:menu
	call :print Esta herramienta restablece la configuracin del Agente de Windows Update.

	echo.    1. Abre la proteccin del sistema (Crea un punto de restauracin).
	echo.    2. Restablece los componentes de Windows Update.
	echo.    3. Elimina los archivos temporales en Windows.
	echo.    4. Abre las opciones de Internet Explorer.
	echo.    5. Ejecuta Chkdsk en la particin de Windows.
	echo.    6. Ejecuta la herramienta Comprobador de archivos del sistema (sfc /scannow).
	echo.    7. Escanea la imagen para detectar daos en el almacn (Argumento DISM /ScanHealth).
	echo.    8. Comprueba si la imagen ha sido marcada como corrupta (Argumento DISM /CheckHealth).
	echo.    9. Realiza las operaciones de reparacin automticamente (Aargumento DISM /RestoreHealth).
	echo.    10. Limpia los componentes reemplazados (Argumento DISM /StartComponentCleanup).
	echo.    11. Cambiar los valores de registros incorrectos (Cambios en Regedit).
	echo.    12. Repara/Restablece la configuracin de Winsock (Configuraciones de Red).
	echo.    13. Forzar la actualizacin de directivas (gpupdate /force).
	echo.    14. Busca actualizaciones de Windows.
	echo.    15. Ejecuta SetupDiag (Requiere .NET Framework 4.6).
	echo.    16. Explora otras soluciones locales.
	echo.    17. Explora otras soluciones en lnea.
	echo.    18. Descarga las herramientas de diagnstico.
	echo.    19. Reiniciar el equipo.
	echo.
	echo.                                           ?. Ayuda.    0. Cerrar.
	echo.

	set /p opcion=Seleccione una opcin: 

	if %opcion% EQU 0 (
		goto close
	) else if %opcion% EQU 1 (
		call :sysProtection
	) else if %opcion% EQU 2 (
		call :components
	) else if %opcion% EQU 3 (
		call :temp
	) else if %opcion% EQU 4 (
		call :iOptions
	) else if %opcion% EQU 5 (
		call :chkdsk
	) else if %opcion% EQU 6 (
		call :sfc
	) else if %opcion% EQU 7 (
		call :dism1
	) else if %opcion% EQU 8 (
		call :dism2
	) else if %opcion% EQU 9 (
		call :dism3
	) else if %opcion% EQU 10 (
		call :dism4
	) else if %opcion% EQU 11 (
		call :regedit
	) else if %opcion% EQU 12 (
		call :winsock
	) else if %opcion% EQU 13 (
		call :gpupdate
	) else if %opcion% EQU 14 (
		call :updates
	) else if %opcion% EQU 15 (
		call :setupDiag
	) else if %opcion% EQU 16 (
		call :local
	) else if %opcion% EQU 17 (
		call :online
	) else if %opcion% EQU 18 (
		call :diagnostic
	) else if %opcion% EQU 19 (
		call :restart
	) else if %opcion% EQU ? (
		call :help
	) else (
		echo.
		echo.Opcin no vlida.
		echo.
		echo.Presione una tecla para regresar al men . . . 
		pause>nul
	)
	 
	goto menu
goto :eof
:: /*************************************************************************************/


:: Abre la proteccin del sistema.
:: void sysProtection();
:: /*************************************************************************************/
:sysProtection
	call :print Abriendo la proteccin del sistema.

	if %familia% NEQ 5 (
		start systempropertiesprotection
	) else (
		echo.
		echo.Lo sentimos, esta opcin no est disponible en este sistema operativo.
		echo.
		echo.Presione una tecla para regresar al men . . . 
		pause>nul
	)
goto :eof
:: /*************************************************************************************/


:: Restablece los componentes de Windows Update.
:: void components();
:: /*************************************************************************************/
:components
	:: ----- Se detienen los servicios de Windows Update -----
	call :print Deteniendo los servicios de Windows Update.
	net stop bits

	call :print Deteniendo los servicios de Windows Update.
	net stop wuauserv

	call :print Deteniendo los servicios de Windows Update.
	net stop appidsvc

	call :print Deteniendo los servicios de Windows Update.
	net stop cryptsvc

	call :print Cancelando el proceso de Windows Update.
	taskkill /im wuauclt.exe /f

	:: ----- Se verifica el estado de los servicios -----
	call :print Verificando el estado de los servicios.

	sc query bits | findstr /I /C:"STOPPED"
	if %errorlevel% NEQ 0 (
		echo.    Error al detener el servicio de Servicio de transferencia inteligente en segundo plano ^(BITS^).
		echo.
		echo.Presione una tecla para cerrar la ventana . . . 
		pause>nul
		goto :eof
	)

	call :print Verificando el estado de los servicios.

	sc query wuauserv | findstr /I /C:"STOPPED"
	if %errorlevel% NEQ 0 (
		echo.    Error al detener el servicio de Windows Update ^(WUAUSERV^).
		echo.
		echo.Presione una tecla para cerrar la ventana . . . 
		pause>nul
		goto :eof
	)

	call :print Verificando el estado de los servicios.

	sc query appidsvc | findstr /I /C:"STOPPED"
	if %errorlevel% NEQ 0 (
		sc query appidsvc | findstr /I /C:"OpenService FAILED 1060"
		if %errorlevel% NEQ 0 (
			echo.    Error al detener el servicio de Identidad de aplicacin ^(APPIDSVC^).
			echo.
			echo.Presione una tecla para cerrar la ventana . . . 
			pause>nul
			if %familia% NEQ 6 goto :eof
		)
	)

	call :print Verificando el estado de los servicios.

	sc query cryptsvc | findstr /I /C:"STOPPED"
	if %errorlevel% NEQ 0 (
		echo.    Error al detener el servicio de Servicios de cifrado ^(CRYPTSVC^).
		echo.
		echo.Presione una tecla para cerrar la ventana . . . 
		pause>nul
		goto :eof
	)
	
	:: ----- Se eliminan los archivos qmgr*.dat -----
	call :print Eliminando los archivos qmgr*.dat.

	del /s /q /f "%ALLUSERSPROFILE%\Application Data\Microsoft\Network\Downloader\qmgr*.dat"
	del /s /q /f "%ALLUSERSPROFILE%\Microsoft\Network\Downloader\qmgr*.dat"

	:: ----- Se renombra la carpeta SoftwareDistribution -----
	call :print Eliminando las copias de seguridad de Distribucin de Software.

	cd /d %SYSTEMROOT%

	if exist "%SYSTEMROOT%\winsxs\pending.xml.bak" (
		del /s /q /f "%SYSTEMROOT%\winsxs\pending.xml.bak"
	)
	if exist "%SYSTEMROOT%\SoftwareDistribution.bak" (
		rmdir /s /q "%SYSTEMROOT%\SoftwareDistribution.bak"
	)
	if exist "%SYSTEMROOT%\system32\Catroot2.bak" (
		rmdir /s /q "%SYSTEMROOT%\system32\Catroot2.bak"
	)
	if exist "%SYSTEMROOT%\WindowsUpdate.log.bak" (
		del /s /q /f "%SYSTEMROOT%\WindowsUpdate.log.bak"
	)

	call :print Renombrando los directorios de Distribucin de Software.

	if exist "%SYSTEMROOT%\winsxs\pending.xml" (
		takeown /f "%SYSTEMROOT%\winsxs\pending.xml"
		attrib -r -s -h /s /d "%SYSTEMROOT%\winsxs\pending.xml"
		ren "%SYSTEMROOT%\winsxs\pending.xml" pending.xml.bak
	)
	if exist "%SYSTEMROOT%\SoftwareDistribution" (
		attrib -r -s -h /s /d "%SYSTEMROOT%\SoftwareDistribution"
		ren "%SYSTEMROOT%\SoftwareDistribution" SoftwareDistribution.bak
		if exist "%SYSTEMROOT%\SoftwareDistribution" (
			echo.
			echo.    Failed to rename the SoftwareDistribution folder.
			echo.
			echo.Press any key to continue . . .
			pause>nul
			goto :eof
		)
	)
	if exist "%SYSTEMROOT%\system32\Catroot2" (
		attrib -r -s -h /s /d "%SYSTEMROOT%\system32\Catroot2"
		ren "%SYSTEMROOT%\system32\Catroot2" Catroot2.bak
	)
	if exist "%SYSTEMROOT%\WindowsUpdate.log" (
		attrib -r -s -h /s /d "%SYSTEMROOT%\WindowsUpdate.log"
		ren "%SYSTEMROOT%\WindowsUpdate.log" WindowsUpdate.log.bak
	)

	:: ----- Se restablecen los servicios para el descriptor de seguridad -----
	call :print Restableciendo los servicios de BITS y Windows Update para el descriptor de seguridad predeterminado.

	sc.exe sdset wuauserv D:(A;CI;CCLCSWRPLORC;;;AU)(A;;CCDCLCSWRPWPDTLOCRSDRCWDWO;;;BA)(A;;CCDCLCSWRPWPDTLOCRSDRCWDWO;;;SY)S:(AU;FA;CCDCLCSWRPWPDTLOSDRCWDWO;;;WD)
	sc.exe sdset bits D:(A;CI;CCDCLCSWRPWPDTLOCRSDRCWDWO;;;SY)(A;;CCDCLCSWRPWPDTLOCRSDRCWDWO;;;BA)(A;;CCLCSWLOCRRC;;;IU)(A;;CCLCSWLOCRRC;;;SU)S:(AU;SAFA;WDWO;;;BA)
	sc.exe sdset cryptsvc D:(A;;CCLCSWRPWPDTLOCRRC;;;SY)(A;;CCDCLCSWRPWPDTLOCRSDRCWDWO;;;BA)(A;;CCLCSWLOCRRC;;;IU)(A;;CCLCSWLOCRRC;;;SU)(A;;CCLCSWRPWPDTLOCRRC;;;SO)(A;;CCLCSWLORC;;;AC)(A;;CCLCSWLORC;;;S-1-15-3-1024-3203351429-2120443784-2872670797-1918958302-2829055647-4275794519-765664414-2751773334)
	sc.exe sdset trustedinstaller D:(A;CI;CCDCLCSWRPWPDTLOCRSDRCWDWO;;;SY)(A;;CCDCLCSWRPWPDTLOCRRC;;;BA)(A;;CCLCSWLOCRRC;;;IU)(A;;CCLCSWLOCRRC;;;SU)S:(AU;SAFA;WDWO;;;BA)

	:: ----- Se vuelven a registrar los archivos de BITS -----
	call :print Registrando los archivos de BITS.

	cd /d %SYSTEMROOT%\system32
	regsvr32.exe /s atl.dll
	regsvr32.exe /s urlmon.dll
	regsvr32.exe /s mshtml.dll
	regsvr32.exe /s shdocvw.dll
	regsvr32.exe /s browseui.dll
	regsvr32.exe /s jscript.dll
	regsvr32.exe /s vbscript.dll
	regsvr32.exe /s scrrun.dll
	regsvr32.exe /s msxml.dll
	regsvr32.exe /s msxml3.dll
	regsvr32.exe /s msxml6.dll
	regsvr32.exe /s actxprxy.dll
	regsvr32.exe /s softpub.dll
	regsvr32.exe /s wintrust.dll
	regsvr32.exe /s dssenh.dll
	regsvr32.exe /s rsaenh.dll
	regsvr32.exe /s gpkcsp.dll
	regsvr32.exe /s sccbase.dll
	regsvr32.exe /s slbcsp.dll
	regsvr32.exe /s cryptdlg.dll
	regsvr32.exe /s oleaut32.dll
	regsvr32.exe /s ole32.dll
	regsvr32.exe /s shell32.dll
	regsvr32.exe /s initpki.dll
	regsvr32.exe /s wuapi.dll
	regsvr32.exe /s wuaueng.dll
	regsvr32.exe /s wuaueng1.dll
	regsvr32.exe /s wucltui.dll
	regsvr32.exe /s wups.dll
	regsvr32.exe /s wups2.dll
	regsvr32.exe /s wuweb.dll
	regsvr32.exe /s qmgr.dll
	regsvr32.exe /s qmgrprxy.dll
	regsvr32.exe /s wucltux.dll
	regsvr32.exe /s muweb.dll
	regsvr32.exe /s wuwebv.dll

	:: ----- Se restablece Winsock -----
	call :print Restableciendo Winsock.
	netsh winsock reset

	:: ----- Se restablece el Proxy -----
	call :print Restableciendo el Proxy.

	if %familia% EQU 5 (
		proxycfg.exe -d
	) else (
		netsh winhttp reset proxy
	)

	:: ----- Se establecen los servicios automticos -----
	call :print Restableciendo los servicios como automticos.
	sc.exe config wuauserv start= auto
	sc.exe config bits start= delayed-auto
	sc.exe config cryptsvc start= auto
	sc.exe config TrustedInstaller start= demand
	sc.exe config DcomLaunch start= auto

	:: ----- Se inician los servicios de Windows Update -----
	call :print Reiniciando servicios de Windows Update.
	net start bits

	call :print Reiniciando servicios de Windows Update.
	net start wuauserv

	call :print Reiniciando servicios de Windows Update.
	net start appidsvc

	call :print Reiniciando servicios de Windows Update.
	net start cryptsvc

	call :print Reiniciando servicios de Windows Update.
	net start DcomLaunch

	:: ----- Se finaliza el proceso -----
	call :print La operacin se complet correctamente.

	echo.Presione una tecla para regresar al men . . . 
	pause>nul
goto :eof
:: /*************************************************************************************/


:: Elimina los archivos temporales del sistema.
:: void temp();
:: /*************************************************************************************/
:temp
	call :print Eliminando los archivos temporales del sistema.

	del /s /f /q "%TEMP%\*.*"
	del /s /f /q "%SYSTEMROOT%\Temp\*.*"

	echo.
	echo.Presione una tecla para regresar al men . . . 
	pause>nul
goto :eof
:: /*************************************************************************************/


:: Abre las opciones de Internet Explorer.
:: void iOptions();
:: /*************************************************************************************/
:iOptions
	call :print Abriendo las opciones de Internet Explorer.

	start InetCpl.cpl
goto :eof
:: /*************************************************************************************/


:: Verificar y reparar errores en el disco.
:: void chkdsk();
:: /*************************************************************************************/
:chkdsk
	call :print Comprueba el sistema de archivos y los metadatos del sistema de archivos de un volumen en busca de errores lgicos y fsicos (CHKDSK.exe).

	chkdsk %SYSTEMDRIVE% /f /r

	if %errorlevel% EQU 0 (
		echo.
		echo.La operacin se complet correctamente.
	) else (
		echo.
		echo.Se produjo un error durante la operacin.
	)

	echo.
	echo.Presione una tecla para regresar al men . . . 
	pause>nul
goto :eof
:: /*************************************************************************************/


:: Escanea la proteccin del sistema de archivos.
:: void sfc();
:: /*************************************************************************************/
:sfc
	call :print Escaneando la proteccin del sistema de archivos.

	if %familia% NEQ 5 (
		sfc /scannow
	) else (
		echo.Lo sentimos, esta opcin no est disponible en este sistema operativo.
	)

	if %errorlevel% EQU 0 (
		echo.
		echo.La operacin se complet correctamente.
	) else (
		echo.
		echo.Se produjo un error durante la operacin.
	)

	echo.
	echo.Presione una tecla para regresar al men . . . 
	pause>nul
goto :eof
:: /*************************************************************************************/


:: Escanea la imagen del sistema en busca de errores.
:: void dism1();
:: /*************************************************************************************/
:dism1
	call :print Escaneando la imagen del sistema en busca de errores.

	if %familia% EQU 8 (
		Dism.exe /Online /Cleanup-Image /ScanHealth
	) else if %familia% EQU 10 (
		Dism.exe /Online /Cleanup-Image /ScanHealth
	) else (
		echo.Lo sentimos, esta opcin no est disponible en este sistema operativo.
	)

	if %errorlevel% EQU 0 (
		echo.
		echo.La operacin se complet correctamente.
	) else (
		echo.
		echo.Se produjo un error durante la operacin.
	)

	echo.
	echo.Presione una tecla para regresar al men . . . 
	pause>nul
goto :eof
:: /*************************************************************************************/


:: Verifica los errores encontradas en la imagen.
:: void dism2();
:: /*************************************************************************************/
:dism2
	call :print Verificando los errores encontradas en la imagen.

	if %familia% EQU 8 (
		Dism.exe /Online /Cleanup-Image /CheckHealth
	) else if %familia% EQU 10 (
		Dism.exe /Online /Cleanup-Image /CheckHealth
	) else (
		echo.Lo sentimos, esta opcin no est disponible en este sistema operativo.
	)

	if %errorlevel% EQU 0 (
		echo.
		echo.La operacin se complet correctamente.
	) else (
		echo.
		echo.Se produjo un error durante la operacin.
	)

	echo.
	echo.Presione una tecla para regresar al men . . . 
	pause>nul
goto :eof
:: /*************************************************************************************/


:: Repara los errores en la imagen del sistema.
:: void dism3();
:: /*************************************************************************************/
:dism3
	call :print Reparando los errores en la imagen del sistema.

	if %familia% EQU 8 (
		Dism.exe /Online /Cleanup-Image /RestoreHealth
	) else if %familia% EQU 10 (
		Dism.exe /Online /Cleanup-Image /RestoreHealth
	) else (
		echo.Lo sentimos, esta opcin no est disponible en este sistema operativo.
	)

	if %errorlevel% EQU 0 (
		echo.
		echo.La operacin se complet correctamente.
	) else (
		echo.
		echo.Se produjo un error durante la operacin.
	)

	echo.
	echo.Presione una tecla para regresar al men . . . 
	pause>nul
goto :eof
:: /*************************************************************************************/


:: Limpia los componentes eliminados.
:: void dism4();
:: /*************************************************************************************/
:dism4
	call :print Limpiando los componentes eliminados.

	if %familia% EQU 8 (
		Dism.exe /Online /Cleanup-Image /StartComponentCleanup
	) else if %familia% EQU 10 (
		Dism.exe /Online /Cleanup-Image /StartComponentCleanup
	) else (
		echo.Lo sentimos, esta opcin no est disponible en este sistema operativo.
	)

	if %errorlevel% EQU 0 (
		echo.
		echo.La operacin se complet correctamente.
	) else (
		echo.
		echo.Se produjo un error durante la operacin.
	)

	echo.
	echo.Presione una tecla para regresar al men . . . 
	pause>nul
goto :eof
:: /*************************************************************************************/


:: Cambiando los valores incorrectos que pueden existir.
:: void regedit();
:: /*************************************************************************************/
:regedit
	for /f "tokens=1-5 delims=/., " %%a in ("%date%") do (
		set now=%%a%%b%%c%%d%time:~0,2%%time:~3,2%
	)

	if not exist "%USERPROFILE%\Desktop\Backup\Regedit\%now%\" (
		mkdir "%USERPROFILE%\Desktop\Backup\Regedit\%now%\"
	)

	:: ----- Se crea una copia de seguridad del registro -----
	call :print Creando una copia del registro en: %USERPROFILE%\Desktop\Backup\Regedit\%now%\

	if exist "%USERPROFILE%\Desktop\Backup\Regedit\%now%\HKLM.reg" (
		echo.Se ha producido un error inesperado.
		echo.
		echo.    No se realizaron cambios en el registro.
		echo.    Intntalo ms tarde.
		echo.
		echo.Presione una tecla para regresar al men . . . 
		pause>nul
		goto :eof
	) else (
		reg Export HKCR "%USERPROFILE%\Desktop\Backup\Regedit\%now%\HKCR.reg"
		reg Export HKCU "%USERPROFILE%\Desktop\Backup\Regedit\%now%\HKCU.reg"
		reg Export HKLM "%USERPROFILE%\Desktop\Backup\Regedit\%now%\HKLM.reg"
		reg Export HKU "%USERPROFILE%\Desktop\Backup\Regedit\%now%\HKU.reg"
		reg Export HKCC "%USERPROFILE%\Desktop\Backup\Regedit\%now%\HKCC.reg"
	)

	:: ----- Se verifica que se ha creado la copia del registro -----
	call :print Verificando la copia de seguridad.

	if not exist "%USERPROFILE%\Desktop\Backup\Regedit\%now%\HKLM.reg" (
		echo.Se ha producido un error inesperado.
		echo.
		echo.    Algo sali mal.
		echo.    Crea manualmente una copia de seguridad del registro antes de continuar.
		echo.
		echo.Presione una tecla para continuar . . . 
		pause>nul
	) else (
		echo.La operacin se complet correctamente.
		echo.
	)

	:: ----- Se eliminan subclaves del registro -----
	call :print Eliminando valores del registro.

	reg delete "HKCU\Software\Microsoft\Windows\CurrentVersion\AdvertisingInfo" /f
	reg delete "HKCU\Software\Microsoft\Windows\CurrentVersion\Policies\WindowsUpdate" /f
	reg delete "HKCU\Software\Microsoft\WindowsSelfHost" /f
	reg delete "HKLM\Software\Microsoft\Windows\CurrentVersion\WindowsStore\WindowsUpdate" /f
	reg delete "HKLM\Software\Microsoft\Windows\CurrentVersion\WindowsUpdate" /f
	reg delete "HKLM\Software\Microsoft\WindowsSelfHost" /f
	reg delete "HKLM\Software\WOW6432Node\Microsoft\Windows\CurrentVersion\WindowsStore\WindowsUpdate" /f

	reg delete "HKLM\COMPONENTS\PendingXmlIdentifier" /f
	reg delete "HKLM\COMPONENTS\NextQueueEntryIndex" /f
	reg delete "HKLM\COMPONENTS\AdvancedInstallersNeedResolving" /f
	reg delete "HKLM\SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate" /f
	
	reg delete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate" /v ResetClient /f
	reg delete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate" /v ResetDataStoreReason /f

	reg delete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate" /v PingID /f
	reg delete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate" /v AccountDomainSid /f
	reg delete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate" /v SusClientId /f
	reg delete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate" /v SusClientIDValidation /f

	reg delete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate\Auto Update" /v AUState /f

	reg delete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate\Auto Update" /v LastWaitTimeout /f
	reg delete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate\Auto Update" /v DetectionstartTime /f
	reg delete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate\Auto Update" /v NextDetectionTime /f

	reg delete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate\Auto Update\RebootRequired" /f

	reg delete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate\Auto Update\Results" /f

	reg delete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate\Reporting" /v SamplingValue /f
	reg delete "HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate\Services" /v ReregisterAuthorizationCab /f

	:: ----- Se agregan subclaves al registro -----
	call :print Agregando valores al registro.

	set key=HKLM\SOFTWARE\Microsoft\WindowsUpdate\UX
	call :addReg "%key%" "IsConvergedUpdateStackEnabled" "REG_DWORD" "0"

	set key=HKLM\SOFTWARE\Microsoft\WindowsUpdate\UX\Settings
	call :addReg "%key%" "UxOption" "REG_DWORD" "0"

	set key=HKCU\Software\Microsoft\Windows\CurrentVersion\Explorer\User Shell Folders
	call :addReg "%key%" "AppData" "REG_EXPAND_SZ" "%USERPROFILE%\AppData\Roaming"

	set key=HKLM\Software\Microsoft\Windows\CurrentVersion\Explorer\User Shell Folders
	call :addReg "%key%" "AppData" "REG_EXPAND_SZ" "%USERPROFILE%\AppData\Roaming"

	set key=HKU\.DEFAULT\Software\Microsoft\Windows\CurrentVersion\Explorer\User Shell Folders
	call :addReg "%key%" "AppData" "REG_EXPAND_SZ" "%USERPROFILE%\AppData\Roaming"

	reg add "HKLM\SYSTEM\CurrentControlSet\Control\BackupRestore\FilesNotToBackup" /f

	reg query "HKLM\SOFTWARE\Policies\Microsoft\Windows\CurrentVersion\Internet Settings" /v Security_HKLM_only | find /i "Security_HKLM_Only" | find "1"

	if %errorlevel% EQU 0 (
		set key=HKLM\Software\Microsoft\Windows\CurrentVersion\Internet Settings\ZoneMap\Domains
	) else (
		set key=HKCU\Software\Microsoft\Windows\CurrentVersion\Internet Settings\ZoneMap\Domains
	)
	
	call :addReg "%key%\microsoft.com\update" "http" "REG_DWORD" "2"
	call :addReg "%key%\microsoft.com\update" "https" "REG_DWORD" "2"
	call :addReg "%key%\microsoft.com\windowsupdate" "http" "REG_DWORD" "2"
	call :addReg "%key%\update.microsoft.com" "http" "REG_DWORD" "2"
	call :addReg "%key%\update.microsoft.com" "https" "REG_DWORD" "2"
	call :addReg "%key%\windowsupdate.com" "http" "REG_DWORD" "2"
	call :addReg "%key%\windowsupdate.microsoft.com" "http" "REG_DWORD" "2"
	call :addReg "%key%\download.microsoft.com" "http" "REG_DWORD" "2"
	call :addReg "%key%\windowsupdate.com" "http" "REG_DWORD" "2"
	call :addReg "%key%\windowsupdate.com" "https" "REG_DWORD" "2"
	call :addReg "%key%\windowsupdate.com\download" "http" "REG_DWORD" "2"
	call :addReg "%key%\windowsupdate.com\download" "https" "REG_DWORD" "2"
	call :addReg "%key%\download.windowsupdate.com" "http" "REG_DWORD" "2"
	call :addReg "%key%\download.windowsupdate.com" "https" "REG_DWORD" "2"
	call :addReg "%key%\windows.com\wustat" "http" "REG_DWORD" "2"
	call :addReg "%key%\wustat.windows.com" "http" "REG_DWORD" "2"
	call :addReg "%key%\microsoft.com\ntservicepack" "http" "REG_DWORD" "2"
	call :addReg "%key%\ntservicepack.microsoft.com" "http" "REG_DWORD" "2"
	call :addReg "%key%\microsoft.com\ws" "http" "REG_DWORD" "2"
	call :addReg "%key%\microsoft.com\ws" "https" "REG_DWORD" "2"
	call :addReg "%key%\ws.microsoft.com" "http" "REG_DWORD" "2"
	call :addReg "%key%\ws.microsoft.com" "https" "REG_DWORD" "2"

	:: ----- Se finaliza el proceso -----
	call :Print La operacin se complet correctamente.

	echo.Presione una tecla para regresar al men . . . 
	pause>nul
goto :eof
:: /*************************************************************************************/


:: Restablece las configuraciones del control Winsock.
:: void winsock();
:: /*************************************************************************************/
:winsock
	:: ----- Se restablece el control Winsock -----
	call :print Reset Winsock control.

	call :print Restableciendo registros de transacciones.
	fsutil resource setautoreset true C:\

	call :Print Restableciendo TPC/IP.
	netsh int ip reset

	call :Print Restableciendo Winsock.
	netsh winsock reset

	call :Print Restaurando valores predeterminados de directiva.
	netsh advfirewall reset

	call :Print Restableciendo el cach DNS.
	ipconfig /flushdns

	call :Print Configurando Proxy.
	netsh winhttp reset proxy

	:: ----- Se finaliza el proceso -----
	call :Print La operacin se complet correctamente.

	echo.Presione una tecla para regresar al men . . . 
	pause>nul
goto :eof
:: /*************************************************************************************/


:: Forzando la actualizacin de directivas.
:: void gpupdate();
:: /*************************************************************************************/
:gpupdate
	call :print Forzando la actualizacin de directivas.

	if %familia% NEQ 5 (
		gpupdate /force
	) else (
		echo.Lo sentimos, esta opcin no est disponible en este sistema operativo.
	)

	if %errorlevel% EQU 0 (
		echo.
		echo.La operacin se complet correctamente.
	) else (
		echo.
		echo.Se produjo un error durante la operacin.
	)

	echo.
	echo.Presione una tecla para regresar al men . . . 
	pause>nul
goto :eof
:: /*************************************************************************************/


:: Busca nuevas actualizaciones.
:: void updates();
:: /*************************************************************************************/
:updates
	call :print Buscando actualizaciones.

	echo.Por favor espere . . .
	echo.

	wuauclt /resetauthorization /detectnow

	if %familia% EQU 10 (
		start ms-settings:windowsupdate-action
	) else (
		if %familia% NEQ 5 (
			start wuapp.exe
		) else (
			echo.
			echo.Se ha producido un error inesperado.
			echo.
			echo.Presione una tecla para regresar al men . . . 
			pause>nul
		)
	)
goto :eof
:: /*************************************************************************************/


:: Ejecuta SetupDiag.
:: void setupDiag();
:: /*************************************************************************************/
:setupDiag
	for /f "tokens=1-5 delims=/., " %%a in ("%date%") do (
		set now=%%a%%b%%c%%d%time:~0,2%%time:~3,2%
	)

	if not exist "%USERPROFILE%\Desktop\Backup\Logs\%now%\" (
		mkdir "%USERPROFILE%\Desktop\Backup\Logs\%now%\"
	)

	call :print Ejecuta la herramienta de diagnstico independiente SetupDiag

	if %familia% EQU 10 (
		call "%~dp0SetupDiag.exe" /Output:"%USERPROFILE%\Desktop\Backup\Logs\%now%\WindowsUpdate.log" /Format:log
	) else (
		echo.Lo sentimos, esta opcin no est disponible en este sistema operativo.
	)

	echo.
	echo.Presione una tecla para regresar al men . . . 
	pause>nul
goto :eof
:: /*************************************************************************************/


:: Abre el solucionador de problemas del equipo.
:: void local();
:: /*************************************************************************************/
:local
	call :print Buscando soluciones en el equipo.

	if %familia% NEQ 5 (
		start control.exe /name Microsoft.Troubleshooting
	) else (
		echo.Lo sentimos, esta opcin no est disponible en este sistema operativo.
		echo.
		echo.Presione una tecla para regresar al men . . . 
		pause>nul
	)
goto :eof
:: /*************************************************************************************/


:: Abre el enlace de solucin de problemas de Windows Update.
:: void online();
:: /*************************************************************************************/
:online
	call :print Buscando soluciones en lnea.

	start https://support.microsoft.com/es-us/gp/windows-update-issues/
goto :eof
:: /*************************************************************************************/


:: Ejecuta el reinicio del sistema.
:: void restart();
:: /*************************************************************************************/
:restart
	call :print Reiniciando el sistema.

	if %familia% NEQ 5 (
		echo.    El sistema se reiniciar  en 60 segundos.
		echo.    Por favor guarde todos los documentos abiertos.

		start shutdown.exe /r /t 60 /c "El sistema se reiniciar  en 60 segundos. Por favor guarde todos los documentos abiertos."
	) else (
		echo.Lo sentimos, esta opcin no est disponible en este sistema operativo.
	)

	echo.
	echo.Presione una tecla para regresar al men . . . 
	pause>nul
goto :eof
:: /*************************************************************************************/


:: Abre el archivo de ayuda.
:: void help();
:: /*************************************************************************************/
:help
	start http://docs.wureset.com/
goto :eof
:: /*************************************************************************************/


:: Crea el men de descarga de diagnsticos.
:: void diagnostic();
:: /*************************************************************************************/
:diagnostic
	call :print Descargue y ejecute el diagnstico para su sistema.

	echo.    1. Windows Update para Windows 7, Windows 8 y Windows 8.1.
	echo.    2. Windows Update para Windows 10.
	echo.    3. Aplicaciones en Windows 8.1.
	echo.    4. Aplicaciones en Windows 10.
	echo.
	echo.                                                        0. Atrs.
	echo.

	set /p opcion=Seleccione una opcin: 

	if %opcion% EQU 0 (
		goto menu
	) else if %opcion% EQU 1 (
		start http://go.microsoft.com/?linkid=9830262
	) else if %opcion% EQU 2 (
		start http://aka.ms/diag_wu
	) else if %opcion% EQU 3 (
		start http://go.microsoft.com/fwlink/p/?LinkId=268423
	) else if %opcion% EQU 4 (
		start http://aka.ms/diag_apps10
	) else (
		echo.
		echo.Opcin no vlida.
		echo.
		echo.Presione una tecla para cerrar la ventana . . . 
		pause>nul
	)
 
	goto diagnostic
goto :eof
:: /*************************************************************************************/


:: Finalizando la herramienta.
:: void close();
:: /*************************************************************************************/
:close
	exit
goto :eof
:: /*************************************************************************************/

